#!/bin/sh
#
# MIRACLE LINUX CORPORATION, 2003, All Rights Reserved.
#
# $Id: gcore.sh,v 1.1 2003/05/01 13:11:24 jyoshida Exp $
#

pid=
executable=
corefile=

_print_usage()
{
    echo "Usage `basename $1` [-c core] [executable] pid"
}

while getopts c:h opt ; do
    case $opt in
      c)
	corefile=$OPTARG
	;;
      h)
	_print_usage $0
	exit 0
	;;
      *)
	_print_usage $0
	exit 1
	;;
    esac
done

shift $((OPTIND-1))
if [ -z "$1" ] ; then
    _print_usage $0
    exit 1
fi

echo $1 | grep '^[0-9]\+$' > /dev/null 2>&1
if [ $? = 0 ] ; then
    pid=$1
else
    if [ ! -x $1 ] ; then
	echo "$1: No such executable."
	exit 1
    fi
    executable=$1
    pid=$2
fi

kill -0 $pid > /dev/null 2>&1
if [ $? '!=' 0 ] ; then
    echo "$pid: No such process or Not owner."
    exit 1
fi

if [ x$executable = x ] ; then
    if [ x$corefile = x ] ; then
	gdb << END >/dev/null 2>&1
attach $pid
generate-core-file
detach
quit
END
	corefile=core.$pid
    else
	gdb << END >/dev/null 2>&1
attach $pid
generate-core-file $corefile
detach
quit
END
    fi
else
    if [ x$corefile = x ] ; then
	gdb $executable << END >/dev/null 2>&1
attach $pid
generate-core-file
detach
quit
END
	corefile=core.$pid
    else
	gdb $executable << END >/dev/null 2>&1
attach $pid
generate-core-file $corefile
detach
quit
END
    fi
fi

if [ $? = 0 ] ; then
    echo "Saved corefile $corefile"
else
    exit 1
fi

exit 0
